# syntax=docker-registry.wikimedia.org/repos/releng/blubber/buildkit:v0.18.0
version: v4
base: docker-registry.wikimedia.org/openjdk-17-jdk
lives:
  in: /datahub/datahub-mae-consumer

variants:
  datahub-source:
    lives:
      in: /datahub
    base: docker-registry.wikimedia.org/bullseye
    apt: { packages: [ 'git', 'ca-certificates' ] }
    builders:
      - custom:
          command:
            - git
            - clone
            - '--branch'
            - 'v0.13.3'
            - '--single-branch'
            - "https://github.com/datahub-project/datahub.git"
            - "/datahub"
      - custom:
          command:
            - chmod
            - +x
            - /datahub/docker/datahub-mae-consumer/start.sh

  dockerize:
    base: docker-registry.wikimedia.org/golang1.19
    builder:
      command: [ 'go', 'install', 'github.com/jwilder/dockerize@v0.6.1']

  build:
    lives:
      in: /datahub
    apt: { packages: [ 'git' ] }
    builder:
      command:
        - ./gradlew
        - -Dhttp.proxyHost=${HTTP_PROXY:+webproxy}
        - -Dhttps.proxyHost=${HTTPS_PROXY:+webproxy}
        - -Dhttp.proxyPort=${HTTP_PROXY:+8080}
        - -Dhttps.proxyPort=${HTTPS_PROXY:+8080}
        - -Dhttp.nonProxyHosts=${NO_PROXY:+127.0.0.1|::1|localhost|.wmnet|.wikimedia.org}
        - :metadata-jobs:mae-consumer-job:build
      requirements:
        - from: datahub-source
          source: /datahub
          destination: /datahub

  prepare:
    apt: { packages: [ 'wget' ] }
    builders:
      - custom:
          command: [ 'wget', '--no-verbose' ,'https://github.com/open-telemetry/opentelemetry-java-instrumentation/releases/download/v1.24.0/opentelemetry-javaagent.jar', '-O', '/tmp/opentelemetry-javaagent.jar']
      - custom:
          command: [ 'wget', '--no-verbose' ,'https://repo1.maven.org/maven2/io/prometheus/jmx/jmx_prometheus_javaagent/0.18.0/jmx_prometheus_javaagent-0.18.0.jar', '-O', '/tmp/jmx_prometheus_javaagent.jar']

  production:
    apt: { packages: [ 'wmf-certificates' ] }
    copies:
      - from: build
        source: /datahub/metadata-jobs/mae-consumer-job/build/libs/mae-consumer-job.jar
        destination: /datahub/datahub-mae-consumer/bin/mae-consumer-job.jar
      - from: datahub-source
        source: /datahub/metadata-models/src/main/resources/entity-registry.yml
        destination: /datahub/datahub-mae-consumer/resources/entity-registry.yml
      - from: datahub-source
        source: /datahub/docker/datahub-mae-consumer/start.sh
        destination: /datahub/datahub-mae-consumer/scripts/start.sh
      - from: datahub-source
        source: /datahub/docker/monitoring/client-prometheus-config.yaml
        destination: /datahub/datahub-mae-consumer/scripts/prometheus-config.yaml
      - from: dockerize
        source: /go/bin/dockerize
        destination: /usr/local/bin
      - from: prepare
        source: /tmp/opentelemetry-javaagent.jar
        destination: /
      - from: prepare
        source: /tmp/jmx_prometheus_javaagent.jar
        destination: /
    entrypoint: ['/bin/sh', '-c', 'cd / && /datahub/datahub-mae-consumer/scripts/start.sh']

